
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class ProductsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const products = await db.products.create(
            {
                id: data.id || undefined,
        
        product_type: data.product_type
        ||
        null
            ,
            
        name: data.name
        ||
        null
            ,
            
        description: data.description
        ||
        null
            ,
            
        price_supercharged: data.price_supercharged
        ||
        null
            ,
            
        expires_at: data.expires_at
        ||
        null
            ,
            
        max_purchases: data.max_purchases
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        published_at: data.published_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await products.setCreated_by_user( data.created_by_user || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.products.getTableName(),
                belongsToColumn: 'thumbnail_image',
                belongsToId: products.id,
            },
            data.thumbnail_image,
            options,
        );
        

        return products;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const productsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                product_type: item.product_type
            ||
            null
            ,
            
                name: item.name
            ||
            null
            ,
            
                description: item.description
            ||
            null
            ,
            
                price_supercharged: item.price_supercharged
            ||
            null
            ,
            
                expires_at: item.expires_at
            ||
            null
            ,
            
                max_purchases: item.max_purchases
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                published_at: item.published_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const products = await db.products.bulkCreate(productsData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < products.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.products.getTableName(),
                    belongsToColumn: 'thumbnail_image',
                    belongsToId: products[i].id,
                },
                data[i].thumbnail_image,
                options,
            );
        }
        

        return products;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const products = await db.products.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.product_type !== undefined) updatePayload.product_type = data.product_type;
        
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.description !== undefined) updatePayload.description = data.description;
        
        
        if (data.price_supercharged !== undefined) updatePayload.price_supercharged = data.price_supercharged;
        
        
        if (data.expires_at !== undefined) updatePayload.expires_at = data.expires_at;
        
        
        if (data.max_purchases !== undefined) updatePayload.max_purchases = data.max_purchases;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.published_at !== undefined) updatePayload.published_at = data.published_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await products.update(updatePayload, {transaction});

        
        
        if (data.created_by_user !== undefined) {
            await products.setCreated_by_user(
              
              data.created_by_user,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.products.getTableName(),
                belongsToColumn: 'thumbnail_image',
                belongsToId: products.id,
            },
            data.thumbnail_image,
            options,
        );
        

        return products;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const products = await db.products.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of products) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of products) {
                await record.destroy({transaction});
            }
        });


        return products;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const products = await db.products.findByPk(id, options);

        await products.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await products.destroy({
            transaction
        });

        return products;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const products = await db.products.findOne(
            { where },
            { transaction },
        );

        if (!products) {
            return products;
        }

        const output = products.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.article_contents_product = await products.getArticle_contents_product({
            transaction
        });
        
        
        output.comic_contents_product = await products.getComic_contents_product({
            transaction
        });
        
        
        output.video_contents_product = await products.getVideo_contents_product({
            transaction
        });
        
        
        output.game_contents_product = await products.getGame_contents_product({
            transaction
        });
        
        
        output.product_purchases_product = await products.getProduct_purchases_product({
            transaction
        });
        
        
        output.content_consumptions_product = await products.getContent_consumptions_product({
            transaction
        });
        
        
        
        
        
        
        
        
        output.thumbnail_image = await products.getThumbnail_image({
            transaction
        });
        
        
        output.created_by_user = await products.getCreated_by_user({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'created_by_user',
        
        where: filter.created_by_user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.created_by_user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.created_by_user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



      {
        model: db.file,
        as: 'thumbnail_image',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'products',
                        'name',
                        filter.name,
                    ),
                };
            }
            
            if (filter.description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'products',
                        'description',
                        filter.description,
                    ),
                };
            }
            

            
            

            
            if (filter.price_superchargedRange) {
                const [start, end] = filter.price_superchargedRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    price_supercharged: {
                    ...where.price_supercharged,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    price_supercharged: {
                    ...where.price_supercharged,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.expires_atRange) {
                const [start, end] = filter.expires_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    expires_at: {
                    ...where.expires_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    expires_at: {
                    ...where.expires_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.max_purchasesRange) {
                const [start, end] = filter.max_purchasesRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    max_purchases: {
                    ...where.max_purchases,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    max_purchases: {
                    ...where.max_purchases,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.published_atRange) {
                const [start, end] = filter.published_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    published_at: {
                    ...where.published_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    published_at: {
                    ...where.published_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.product_type) {
                where = {
                    ...where,
                product_type: filter.product_type,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.products.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'products',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.products.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

